xref: /xnu-10002.1.13/tools/remote_build.sh (revision 1031c584a5e37aff177559b9f69dbd3c8c3fd30a)
1*1031c584SApple OSS Distributions#!/bin/bash
2*1031c584SApple OSS Distributions#
3*1031c584SApple OSS Distributions# Script that rsyncs a source/build tree to a remote server, performs a build,
4*1031c584SApple OSS Distributions# and copies the result back
5*1031c584SApple OSS Distributions#
6*1031c584SApple OSS Distributions
7*1031c584SApple OSS Distributions# This script is invoked instead of the initial recursive make(1) in ./Makefile.
8*1031c584SApple OSS Distributions# First it must cache all binaries that might be used during the build by
9*1031c584SApple OSS Distributions# calling "make print_exports" (any target would work) with an overriden xcrun(1)
10*1031c584SApple OSS Distributions# which caches tools an SDKs into ./BUILD/obj/BuildTools. When the combined
11*1031c584SApple OSS Distributions# source+build tree is rsync-ed to the remote server, we run a script to
12*1031c584SApple OSS Distributions# re-initiate the build using an overriden xcrun(1) which hands back
13*1031c584SApple OSS Distributions# cached tools in ./BUILD/obj/BuildTools instead of whatever Xcode tools are on
14*1031c584SApple OSS Distributions# the remote system (or if no Xcode tools are installed remotely). Finally,
15*1031c584SApple OSS Distributions# the build results are copied back locally.
16*1031c584SApple OSS Distributions#
17*1031c584SApple OSS Distributions
18*1031c584SApple OSS Distributionsfunction die() {
19*1031c584SApple OSS Distributions    echo "$1" 1>&2
20*1031c584SApple OSS Distributions    exit 1
21*1031c584SApple OSS Distributions}
22*1031c584SApple OSS Distributions
23*1031c584SApple OSS Distributions
24*1031c584SApple OSS DistributionsTARGET=
25*1031c584SApple OSS Distributionsdeclare -a ARGS
26*1031c584SApple OSS Distributionsdeclare -a REMOTEARGS
27*1031c584SApple OSS Distributionsindex=0
28*1031c584SApple OSS Distributionsfor arg in "$@"; do
29*1031c584SApple OSS Distributions    case $arg in
30*1031c584SApple OSS Distributions	_REMOTEBUILD_TARGET=*)
31*1031c584SApple OSS Distributions	    TARGET=`echo $arg | awk -F= '{print $2}'`
32*1031c584SApple OSS Distributions	    continue
33*1031c584SApple OSS Distributions	    ;;
34*1031c584SApple OSS Distributions	_REMOTEBUILD_MAKE=*)
35*1031c584SApple OSS Distributions	    MAKE=`echo $arg | awk -F= '{print $2}'`
36*1031c584SApple OSS Distributions	    continue
37*1031c584SApple OSS Distributions	    ;;
38*1031c584SApple OSS Distributions	REMOTEBUILD=*)
39*1031c584SApple OSS Distributions	    # Don't restart another remote build remotely
40*1031c584SApple OSS Distributions	    ;;
41*1031c584SApple OSS Distributions	SRCROOT=*)
42*1031c584SApple OSS Distributions	    continue
43*1031c584SApple OSS Distributions	    ;;
44*1031c584SApple OSS Distributions	OBJROOT=*)
45*1031c584SApple OSS Distributions	    continue
46*1031c584SApple OSS Distributions	    ;;
47*1031c584SApple OSS Distributions	SYMROOT=*)
48*1031c584SApple OSS Distributions	    continue
49*1031c584SApple OSS Distributions	    ;;
50*1031c584SApple OSS Distributions	DSTROOT=*)
51*1031c584SApple OSS Distributions	    continue
52*1031c584SApple OSS Distributions	    ;;
53*1031c584SApple OSS Distributions	CCHROOT=*)
54*1031c584SApple OSS Distributions	    continue
55*1031c584SApple OSS Distributions	    ;;
56*1031c584SApple OSS Distributions	RC_XBS=*)
57*1031c584SApple OSS Distributions	    # Remote build isn't chrooted or special in any way
58*1031c584SApple OSS Distributions	    arg="VERBOSE=YES"
59*1031c584SApple OSS Distributions	    continue
60*1031c584SApple OSS Distributions	    ;;
61*1031c584SApple OSS Distributions	VERBOSE=YES)
62*1031c584SApple OSS Distributions	    set -x
63*1031c584SApple OSS Distributions	    ;;
64*1031c584SApple OSS Distributions    esac
65*1031c584SApple OSS Distributions    ARGS[$index]="$arg"
66*1031c584SApple OSS Distributions    REMOTEARGS[$index]="\"$arg\""
67*1031c584SApple OSS Distributions    index=$(($index+1))
68*1031c584SApple OSS Distributionsdone
69*1031c584SApple OSS Distributions
70*1031c584SApple OSS Distributions
71*1031c584SApple OSS DistributionsRSYNC_ARGS="-azvh"
72*1031c584SApple OSS DistributionsARGS[$index]="REMOTEBUILD="
73*1031c584SApple OSS DistributionsREMOTEARGS[$index]="\"REMOTEBUILD=\""
74*1031c584SApple OSS Distributions
75*1031c584SApple OSS Distributions# For some targets like installsrc, we can't to a remote build
76*1031c584SApple OSS DistributionsSKIPREMOTE=0
77*1031c584SApple OSS Distributionscase $TARGET in
78*1031c584SApple OSS Distributions    clean)
79*1031c584SApple OSS Distributions	SKIPREMOTE=1
80*1031c584SApple OSS Distributions	;;
81*1031c584SApple OSS Distributions    installsrc)
82*1031c584SApple OSS Distributions	SKIPREMOTE=1
83*1031c584SApple OSS Distributions	;;
84*1031c584SApple OSS Distributions    installopensource)
85*1031c584SApple OSS Distributions	SKIPREMOTE=1
86*1031c584SApple OSS Distributions	;;
87*1031c584SApple OSS Distributions    cscope)
88*1031c584SApple OSS Distributions	SKIPREMOTE=1
89*1031c584SApple OSS Distributions	;;
90*1031c584SApple OSS Distributions    tags)
91*1031c584SApple OSS Distributions	SKIPREMOTE=1
92*1031c584SApple OSS Distributions	;;
93*1031c584SApple OSS Distributions    help)
94*1031c584SApple OSS Distributions	SKIPREMOTE=1
95*1031c584SApple OSS Distributions	;;
96*1031c584SApple OSS Distributionsesac
97*1031c584SApple OSS Distributions
98*1031c584SApple OSS Distributionsif [ $SKIPREMOTE -eq 1 ]; then
99*1031c584SApple OSS Distributions    exec "$MAKE" "$TARGET" "${ARGS[@]}"
100*1031c584SApple OSS Distributionsfi
101*1031c584SApple OSS Distributions
102*1031c584SApple OSS DistributionsSRC="$(pwd -P)"
103*1031c584SApple OSS DistributionsSRCNAME="$(basename $SRC)"
104*1031c584SApple OSS Distributions
105*1031c584SApple OSS Distributions# Pick up build locations passed in the environment
106*1031c584SApple OSS DistributionsOBJROOT="${OBJROOT}"
107*1031c584SApple OSS DistributionsSYMROOT="${SYMROOT}"
108*1031c584SApple OSS DistributionsDSTROOT="${DSTROOT}"
109*1031c584SApple OSS Distributions
110*1031c584SApple OSS Distributionsif [ -z "${OBJROOT}" ]; then
111*1031c584SApple OSS Distributions    die "OBJROOT not set in environment"
112*1031c584SApple OSS Distributionsfi
113*1031c584SApple OSS Distributionsmkdir -p "${OBJROOT}" || die "Could not create ${OBJROOT}"
114*1031c584SApple OSS Distributions
115*1031c584SApple OSS Distributionsif [ -z "${SYMROOT}" ]; then
116*1031c584SApple OSS Distributions    die "SYMROOT not set in environment"
117*1031c584SApple OSS Distributionsfi
118*1031c584SApple OSS Distributionsmkdir -p "${SYMROOT}" || die "Could not create ${SYMROOT}"
119*1031c584SApple OSS Distributions
120*1031c584SApple OSS Distributionsif [ -z "${DSTROOT}" ]; then
121*1031c584SApple OSS Distributions    die "DSTROOT not set in environment"
122*1031c584SApple OSS Distributionsfi
123*1031c584SApple OSS Distributionsmkdir -p "${DSTROOT}" || die "Could not create ${DSTROOT}"
124*1031c584SApple OSS Distributions
125*1031c584SApple OSS Distributionsif [ "$REMOTEBUILD" = "$SPECIALREMOTEBUILD" ]; then
126*1031c584SApple OSS Distributions    :
127*1031c584SApple OSS Distributionselse
128*1031c584SApple OSS Distributions    DOINSTALLSRC=0
129*1031c584SApple OSS Distributions    REMOTE_SRCREL="./"
130*1031c584SApple OSS Distributions    BUILDTOOLSDIR="$OBJROOT"
131*1031c584SApple OSS Distributions    REMOTE_BUILDTOOLSREL="./BUILD/obj"
132*1031c584SApple OSS Distributions    BUILDSCRIPTDIR="$OBJROOT"
133*1031c584SApple OSS Distributions    REMOTE_BUILDSCRIPTREL="./BUILD/obj"
134*1031c584SApple OSS Distributions    BUILDSCRIPTNAME="build.sh"
135*1031c584SApple OSS Distributions    if [ ! -d "${OBJROOT}/SETUP" ]; then
136*1031c584SApple OSS Distributions    RSYNC_DELETE_EXCLUDED="--delete-excluded"
137*1031c584SApple OSS Distributions    else
138*1031c584SApple OSS Distributions    RSYNC_DELETE_EXCLUDED=""
139*1031c584SApple OSS Distributions    fi
140*1031c584SApple OSS Distributions    if [ ! -e "${SYMROOT}/" ]; then
141*1031c584SApple OSS Distributions	RSYNC_DELETE_SYMROOT=1
142*1031c584SApple OSS Distributions    else
143*1031c584SApple OSS Distributions	RSYNC_DELETE_SYMROOT=0
144*1031c584SApple OSS Distributions    fi
145*1031c584SApple OSS Distributions    if [ ! -e "${DSTROOT}/" ]; then
146*1031c584SApple OSS Distributions	RSYNC_DELETE_DSTROOT=1
147*1031c584SApple OSS Distributions    else
148*1031c584SApple OSS Distributions	RSYNC_DELETE_DSTROOT=0
149*1031c584SApple OSS Distributions    fi
150*1031c584SApple OSS Distributions    TARBUILDDIRS=0
151*1031c584SApple OSS Distributionsfi
152*1031c584SApple OSS Distributions
153*1031c584SApple OSS Distributionsecho "Caching build tools..." 1>&2
154*1031c584SApple OSS Distributionsmkdir -p "${BUILDTOOLSDIR}" || die "Could not create BUILDTOOLSDIR"
155*1031c584SApple OSS Distributions$MAKE print_exports "${ARGS[@]}" XCRUN="${SRC}/tools/xcrun_cache.sh -c \"${BUILDTOOLSDIR}\"" >/dev/null || die "Could not cache build tools"
156*1031c584SApple OSS Distributions
157*1031c584SApple OSS Distributions# Cache the make(1) binary itself
158*1031c584SApple OSS DistributionsMAKE_SDKROOT=`"${SRC}/tools/xcrun_cache.sh" -u "${BUILDTOOLSDIR}" -sdk / -show-sdk-path`
159*1031c584SApple OSS Distributions"${SRC}/tools/xcrun_cache.sh" -c "${BUILDTOOLSDIR}" -sdk "${MAKE_SDKROOT}" -find make >/dev/null || die "Could not cache make"
160*1031c584SApple OSS Distributions
161*1031c584SApple OSS Distributions# Create a canned build script that can restart the build on the remote server.
162*1031c584SApple OSS Distributionsmkdir -p "${BUILDSCRIPTDIR}" || die "Could not create BUILDSCRIPTDIR"
163*1031c584SApple OSS Distributionscat > "${BUILDSCRIPTDIR}/${BUILDSCRIPTNAME}" <<EOF
164*1031c584SApple OSS Distributions#!/bin/sh
165*1031c584SApple OSS Distributionsmkdir -p /private/tmp
166*1031c584SApple OSS Distributionsmkdir -p /private/var/tmp
167*1031c584SApple OSS Distributionsmkdir -p "\${TMPDIR}"
168*1031c584SApple OSS Distributionscd "${REMOTE_SRCREL}"
169*1031c584SApple OSS Distributionsmkdir -p ./BUILD/obj
170*1031c584SApple OSS Distributionsmkdir -p ./BUILD/sym
171*1031c584SApple OSS Distributionsmkdir -p ./BUILD/dst
172*1031c584SApple OSS DistributionsMAKE=\`\$PWD/tools/xcrun_cache.sh -u "\$PWD/${REMOTE_BUILDTOOLSREL}" -sdk / -find make\`
173*1031c584SApple OSS Distributionsif [ -z "\${MAKE}" ]; then exit 1; fi
174*1031c584SApple OSS Distributions\${MAKE} ${TARGET} ${REMOTEARGS[@]} XCRUN="\$PWD/tools/xcrun_cache.sh -u \"\$PWD/${REMOTE_BUILDTOOLSREL}\""
175*1031c584SApple OSS Distributionsret=\$?
176*1031c584SApple OSS Distributionsif [ \$ret -eq 0 ]; then
177*1031c584SApple OSS Distributionsif [ ${TARBUILDDIRS} -eq 1 ]; then
178*1031c584SApple OSS Distributionstar jcf ./BUILD/obj.tar.bz2 --exclude=\*.o --exclude=\*.cpo --exclude=\*.d --exclude=\*.cpd --exclude=\*.non_lto --exclude=\*.ctf --exclude=conf -C ./BUILD/obj . || exit 1
179*1031c584SApple OSS Distributionstar jcf ./BUILD/sym.tar.bz2 -C ./BUILD/sym . || exit 1
180*1031c584SApple OSS Distributionstar jcf ./BUILD/dst.tar.bz2 -C ./BUILD/dst . || exit 1
181*1031c584SApple OSS Distributionsfi
182*1031c584SApple OSS Distributionsfi
183*1031c584SApple OSS Distributionsexit \$ret
184*1031c584SApple OSS DistributionsEOF
185*1031c584SApple OSS Distributionschmod a+x "${BUILDSCRIPTDIR}/${BUILDSCRIPTNAME}"
186*1031c584SApple OSS Distributions#echo "Build script is:"
187*1031c584SApple OSS Distributions#cat "${BUILDSCRIPTDIR}/${BUILDSCRIPTNAME}"
188*1031c584SApple OSS Distributions
189*1031c584SApple OSS Distributionsmkdir -p "${BUILDTOOLSDIR}/empty"
190*1031c584SApple OSS Distributions
191*1031c584SApple OSS Distributionsif [ "$REMOTEBUILD" = "$SPECIALREMOTEBUILD" ]; then
192*1031c584SApple OSS Distributions    :
193*1031c584SApple OSS Distributionselse
194*1031c584SApple OSS Distributions
195*1031c584SApple OSS Distributions    REMOTEBUILD="$REMOTEBUILD"
196*1031c584SApple OSS Distributions    REMOTEBUILDPATH="$REMOTEBUILDPATH"
197*1031c584SApple OSS Distributions
198*1031c584SApple OSS Distributions    if [ -z "$REMOTEBUILDPATH" ]; then
199*1031c584SApple OSS Distributions	WHOAMI=`whoami`
200*1031c584SApple OSS Distributions	case "${REMOTEBUILD}" in
201*1031c584SApple OSS Distributions	    *@*)
202*1031c584SApple OSS Distributions		WHOAMI=`echo "${REMOTEBUILD}" | awk -F@ '{print $1}'`
203*1031c584SApple OSS Distributions		;;
204*1031c584SApple OSS Distributions	esac
205*1031c584SApple OSS Distributions	REMOTEBUILDPATH="/tmp/$WHOAMI"
206*1031c584SApple OSS Distributions    fi
207*1031c584SApple OSS Distributions
208*1031c584SApple OSS Distributions# Construct a unique remote path
209*1031c584SApple OSS Distributions    eval `stat -s "${SRC}"`
210*1031c584SApple OSS Distributions
211*1031c584SApple OSS Distributions    REMOTEBUILDPATH="${REMOTEBUILDPATH}/$st_ino/${SRCNAME}/"
212*1031c584SApple OSS Distributions    echo "Remote path is ${REMOTEBUILD}:${REMOTEBUILDPATH}" 1>&2
213*1031c584SApple OSS Distributions
214*1031c584SApple OSS Distributions    ssh $REMOTEBUILD "mkdir -p \"${REMOTEBUILDPATH}/BUILD/\"{obj,sym,dst}" || die "Could not make remote build directory"
215*1031c584SApple OSS Distributions
216*1031c584SApple OSS Distributions    # Copy source only
217*1031c584SApple OSS Distributions    rsync $RSYNC_ARGS --delete --exclude=\*~ --exclude=.svn --exclude=.git --exclude=/BUILD . $REMOTEBUILD:"${REMOTEBUILDPATH}" || die "Could not rsync source tree"
218*1031c584SApple OSS Distributions
219*1031c584SApple OSS Distributions    # Copy partial OBJROOT (just build tools and build script), and optionally delete everything else
220*1031c584SApple OSS Distributions    rsync $RSYNC_ARGS --delete $RSYNC_DELETE_EXCLUDED --include=/build.sh --include=/BuildTools --include=/BuildTools/\*\* --exclude=\* "${OBJROOT}/" $REMOTEBUILD:"${REMOTEBUILDPATH}/BUILD/obj/" || die "Could not rsync build tree"
221*1031c584SApple OSS Distributions
222*1031c584SApple OSS Distributions    # Delete remote SYMROOT if it has been deleted locally
223*1031c584SApple OSS Distributions    if [ "$RSYNC_DELETE_SYMROOT" -eq 1 ]; then
224*1031c584SApple OSS Distributions	rsync $RSYNC_ARGS --delete "${BUILDTOOLSDIR}/empty/" $REMOTEBUILD:"${REMOTEBUILDPATH}/BUILD/sym/" || die "Could not rsync delete SYMROOT"
225*1031c584SApple OSS Distributions    fi
226*1031c584SApple OSS Distributions
227*1031c584SApple OSS Distributions    # Delete remote DSTROOT if it has been deleted locally
228*1031c584SApple OSS Distributions    if [ "$RSYNC_DELETE_DSTROOT" -eq 1 ]; then
229*1031c584SApple OSS Distributions	rsync $RSYNC_ARGS --delete "${BUILDTOOLSDIR}/empty/" $REMOTEBUILD:"${REMOTEBUILDPATH}/BUILD/dst/" || die "Could not rsync delete DSTROOT"
230*1031c584SApple OSS Distributions    fi
231*1031c584SApple OSS Distributions
232*1031c584SApple OSS Distributions    # Start the build
233*1031c584SApple OSS Distributions    echo ssh $REMOTEBUILD "/bin/bash -c 'cd \"${REMOTEBUILDPATH}\" && ${REMOTE_BUILDSCRIPTREL}/${BUILDSCRIPTNAME}'" 1>&2
234*1031c584SApple OSS Distributions    ssh $REMOTEBUILD "/bin/bash -c 'cd \"${REMOTEBUILDPATH}\" && ${REMOTE_BUILDSCRIPTREL}/${BUILDSCRIPTNAME}'" || die "Could not complete remote build"
235*1031c584SApple OSS Distributions
236*1031c584SApple OSS Distributions    # Copy back build results except for object files (which might be several GB)
237*1031c584SApple OSS Distributions    echo "Copying results back..."
238*1031c584SApple OSS Distributions    rsync $RSYNC_ARGS --no-o --no-g --exclude=\*.o --exclude=\*.cpo --exclude=\*.d --exclude=\*.cpd --exclude=\*.non_lto --exclude=\*.ctf $REMOTEBUILD:"${REMOTEBUILDPATH}/BUILD/obj/" "${OBJROOT}/" || die "Could not rsync build results"
239*1031c584SApple OSS Distributions    rsync $RSYNC_ARGS --no-o --no-g $REMOTEBUILD:"${REMOTEBUILDPATH}/BUILD/sym/" "${SYMROOT}/" || die "Could not rsync build results"
240*1031c584SApple OSS Distributions    rsync $RSYNC_ARGS --no-o --no-g $REMOTEBUILD:"${REMOTEBUILDPATH}/BUILD/dst/" "${DSTROOT}/" || die "Could not rsync build results"
241*1031c584SApple OSS Distributions
242*1031c584SApple OSS Distributionsfi
243*1031c584SApple OSS Distributions
244*1031c584SApple OSS Distributionsexit 0
245